freeslot("MT_ENDPEARL","MT_DIRTBLOC")

local place_cooldown = 1*TICRATE
--Block placing cooldown (default 1*TICRATE - 1 second)
--Life of the block is 10 seconds and additional 1 second for invisible "noclip" block to play crumble sound

local pearlspeed = 30*FRACUNIT
--Pearl throwing speed (default 30*FRACUNIT)

local pearl_cooldown = 3*TICRATE
--Pearl throw cooldown (default 3*TICRATE - 3 seconds)

addHook("NetVars", function(net)
place_cooldown = net(place_cooldown)
pearlspeed = net(pearlspeed)
pearl_cooldown = net(pearl_cooldown)
end)


COM_AddCommand("pearlcooldown",function(p,cool)
local cdown = tonumber(cool)
if cdown == nil
	if gamemap != nil
		CONS_Printf(p,"Current value - "..tostring(pearl_cooldown))
		CONS_Printf(p,"Usage - pearlcooldown *number of ticks*")
		CONS_Printf(p,"Possible values: 1 - 60000")
	end
	return
end
--Cooldown warning below 15 ticks (may be laggy)
if cdown < 30 and gamemap != nil
	CONS_Printf(p,"Cooldown value below 30 ticks is not recommended! Use at your own risk!")
	if cdown < 1
		CONS_Printf(p,"It has been automatically adjusted to 1 tick")
	end
end
--Cooldown limit (1-60000)
if cdown < 1 
	cdown = 1
elseif cdown > 60000
	cdown = 60000
end
pearl_cooldown = cdown
end, 1)


COM_AddCommand("pearlspeed",function(p,spd)
local numspd = tonumber(spd)
if numspd == nil
	if gamemap != nil
		CONS_Printf(p,"Current value - "..tostring(pearlspeed>>FRACBITS))
		CONS_Printf(p,"Usage - pearlspeed *speed in fracunits*")
		CONS_Printf(p,"Possible values: 0 - 10000")
	end
	return
end
--Warning when speed is higher than 100
if numspd > 60 and gamemap != nil
	CONS_Printf(p,"Pearl speed above 60 FRACUNITS is not recommended! Use at your own risk!")
	if numspd > 10000
		CONS_Printf(p,"It has been automatically adjusted to 10000 FRACUNITS")
	end
end
--Speed Limit (0-10000)
if numspd > 10000
	numspd = 10000
elseif numspd < 0
	numspd = 0
end
--"86:86"
pearlspeed = numspd*FRACUNIT
mobjinfo[MT_ENDPEARL].speed = pearlspeed
end, 1)


COM_AddCommand("placecooldown",function(p,cool)
local cdown = tonumber(cool)
if cdown == nil
	if gamemap != nil
		CONS_Printf(p,"Current value - "..tostring(place_cooldown))
		CONS_Printf(p,"Usage - placecooldown *number of ticks*")
		CONS_Printf(p,"Possible values: 1 - 60000")
	end
	return
end
--Cooldown warning below 15 ticks (may be laggy)
if cdown < 15 and gamemap != nil
	CONS_Printf(p,"Cooldown value below 15 ticks is not recommended! Use at your own risk!")
	if cdown < 1
		CONS_Printf(p,"It has been automatically adjusted to 1 tick")
	end
end
--Cooldown limit (1-60000)
if cdown < 1 
	cdown = 1
elseif cdown > 60000
	cdown = 60000
end
place_cooldown = cdown
end, 1)


local function cdownleft(p,isplace)
	--This function is used by the HUD
	local coolleft = 0
	if isplace == true
		if p.placecd == nil
			return 0
		end
		--Cooldown left time should be a fixed value between 0 and FRACUNIT
		--0 - p.placecd is 0, FRACUNIT - p.placecd == place_cooldown
		if p.placecd > place_cooldown
			p.placecd = place_cooldown
		end
		--Prevent division by zero
		if place_cooldown == 0
			place_cooldown = 1
		end
		coolleft = p.placecd * FRACUNIT / place_cooldown
	else
		if p.pearlcd == nil
			return 0
		end
		--Cooldown left time should be a fixed value between 0 and FRACUNIT
		--0 - p.pearlcd is 0, FRACUNIT - p.pearlcd == pearl_cooldown
		if p.pearlcd > pearl_cooldown
			p.pearlcd = pearl_cooldown
		end
		--Prevent division by zero
		if pearl_cooldown == 0
			pearl_cooldown = 1
		end
		coolleft = p.pearlcd * FRACUNIT / pearl_cooldown
	end
	--"222:222"
	if p.powers[pw_super]
		coolleft = (coolleft - FRACUNIT/2) * 2
	end
	--Pearls are always in the 'used' state when exiting
	if p.exiting > 0 and isplace == false
		coolleft = FRACUNIT
	end
	--Prevent negative coolleft
	if coolleft < 1
		coolleft = 0
	end
	--Prevent coolleft higher than FRACUNIT
	if coolleft > FRACUNIT
		coolleft = FRACUNIT
	end
	return coolleft
end


local function IsObjectDead(mo)
	--True - dead or doesn't exist, False - not dead
	if mo == nil
		return true
	end
	if mo.health < 1
		return true
	end
	return false
end


local function PlayerTP(actor)
	if actor == nil
		return
	end
	--If the throwing player object does not exist, kill the pearl
	if actor.target == nil
		actor.state = S_NULL
		return
	end
	--Teleport the throwing player
	local px = actor.x
	local py = actor.y
	local pz = actor.z
	P_TeleportMove(actor.target,px,py,pz)
	actor.state = S_NULL
	return
end


addHook("PlayerThink", function(p)
if p.valid == false
	return
end
if p.mo == nil
	return
end
if p.mo.skin == "steve"
	if p.powers[pw_super]
		p.actionspd = 3*skins["steve"].actionspd/2
		p.normalspeed = skins["steve"].normalspeed
		p.charability = CA_FLY
		--Super Steve has 2 times higher flying speed and doesn't get tired
		if p.powers[pw_tailsfly]
			p.normalspeed = skins["steve"].normalspeed*2
			p.powers[pw_tailsfly] = 1*TICRATE
		end
		--Super Steve can't drown
		if p.powers[pw_underwater]
			p.powers[pw_underwater] = 0
		end
		--Super Steve doesn't fly when on the ground
		if p.mo.z == p.mo.floorz
			p.powers[pw_tailsfly] = 0
		end
	elseif p.charability != CA_SWIM
		--If Steve is not Super Steve but has FLY ability, do this
		p.actionspd = skins["steve"].actionspd
		p.normalspeed = skins["steve"].normalspeed
		p.charability = CA_SWIM
	end
	--If the place cooldown variable is nil create it with value 0
	if p.placecd == nil
		p.placecd = 0
	else
	--Otherwise decrease the value by 1
		p.placecd = p.placecd - 1
	end
	--If the pearl cooldown variable is nil create it with value 0
	if p.pearlcd == nil
		p.pearlcd = 0
	else
	--Otherwise decrease the value by 1
		p.pearlcd = p.pearlcd - 1
	end
	--If player is dead reset cooldowns and return
	if IsObjectDead(p.mo)
		p.pearlcd = 0
		p.placecd = 0
		return
	end
	--Remove abilities on NiGHTS stages
	if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS
		return
	end
	if p.cmd.buttons & BT_CUSTOM1
		--If the current place cooldown is higher than 0
		if p.placecd > 0
			--Place cooldown is halved when in super state
			if p.powers[pw_super] and p.placecd <= place_cooldown / 2
				p.placecd = 0
			else
				return
			end
		end
		--Create block table if nil
		if p.blocks == nil
			p.blocks = {}
		end
		--Remove non-existant blocks from block table
		for k,v in ipairs(p.blocks)
			if v == nil
				table.remove(p.blocks,k)
			end
		end
		--Normal Block spawning (under player's feet and player goes 32 fracunits up)	
		local newz = p.mo.z + 32*FRACUNIT
		local oldz = p.mo.z
		--If player is flipped, place block above the player and change the positions a bit
		if p.mo.eflags & MFE_VERTICALFLIP
			newz = p.mo.z - 32*FRACUNIT - 2*mobjinfo[MT_DIRTBLOC].height/3
			oldz = p.mo.z + 1*mobjinfo[MT_DIRTBLOC].height/3
		end
		--"128:128"
		S_StartSound(p.mo,sfx_s3k6d)
		p.placecd = place_cooldown
		P_TeleportMove(p.mo,p.mo.x,p.mo.y,newz)
		local block = P_SpawnMobj(p.mo.x,p.mo.y,oldz,MT_DIRTBLOC)
		--If player is flipped, flip the block
		if p.mo.eflags & MFE_VERTICALFLIP
			block.flags2 = block.flags2 | MF2_OBJECTFLIP
		end
		--Add the block to block table (currently unused)
		table.insert(p.blocks,block)
	end
	if p.cmd.buttons & BT_CUSTOM2
		--If player is exiting the level, do not spawn pearls
		if p.exiting > 0
			return
		end
		--If the current pearl cooldown is higher than 0
		if p.pearlcd > 0
			--Pearl cooldown is halved when in super state
			if p.powers[pw_super] and p.pearlcd <= pearl_cooldown / 2
				p.pearlcd = 0
			else
				return
			end
		end
		--Spawn the pearl and play throw sound
		local pearl = P_SpawnPlayerMissile(p.mo,MT_ENDPEARL)
		if pearl == nil
			return
		elseif pearl.valid == false
			return
		end
		S_StartSound(p.mo,sfx_s3k4d)
		--If the player is flipped, flip the pearl
		if p.mo.eflags & MFE_VERTICALFLIP
			pearl.flags2 = pearl.flags2 | MF2_OBJECTFLIP
		end
		--"194:194"
		--Set pearl's target to player object
		pearl.target = p.mo
		--Change pearl color to player skin in multiplayer mode
		if multiplayer
			pearl.color = p.mo.color
		else
		--In singleplayer mode change color to default skincolor
			pearl.color = skins["steve"].prefcolor
		end
		--Setting the radius to the player's radius fixes collision issues with walls
		pearl.radius = p.mo.radius
		p.pearlcd = pearl_cooldown
	end
end
end)


function A_DirtSpawn(actor)
	--Resize the block a bit
	actor.scale = (actor.scale * 5) / 4
end


function A_DirtCrumble(actor)
	--Play the crumble sound and remove MF_SOLID flag
	A_Scream(actor)
	actor.flags = actor.flags & ~MF_SOLID
end

--You found this comment? Congratulations!
--You earned nothing but a sense of pride and accomplishment!

function A_PearlShoot(actor)
	--If the thrower player object is dead, kill the pearl
	if IsObjectDead(actor.target)
		actor.state = S_NULL
		return
	elseif actor.target.skin != "steve"
		actor.state = S_NULL
		return
	end
	--"222:222"
	--If the thrower player is in exitlevel state, kill the pearl
	if actor.target != nil
		if actor.target.player != nil
			if actor.target.player.exiting > 0
				actor.state = S_NULL
				return
			end
		end
	end
	--If pearl has hit the floor (Z == floor Z) or a wall (horizontal momentum == 0), teleport player
	if actor.z == actor.floorz or (actor.momx == 0 and actor.momy == 0)
		PlayerTP(actor)
	elseif actor.z + actor.height == actor.ceilingz
	--If the pearl has hit the ceiling (Z == ceiling Z), teleport player but change Z to match player and pearl height difference
		actor.z = actor.z - (actor.target.height - actor.height)
		PlayerTP(actor)
	end
end


hud.add(function(v,p,cam)
if p.valid == false
	return
end
if p.mo == nil
	return
end
--Remove Steve HUD on NiGHTS stages
if mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS
	return
end
if p.mo.skin == "steve"
	--Check if the HUD patches are valid (if not then reset patch data)
	if v.endperli != nil
		if v.endperli.valid == false
			v.endperli = nil
			v.dirtblci = nil
			v.stevebar = nil
		end
	else
	--Set 'used' and 'ready' colors (used - 21, ready - 10)
		v.colstvus = 21
		v.colstvre = 10
	end
	--Loading the HUD patches
	if v.patchExists("ENDPERLI")
		if v.endperli == nil
			v.endperli = v.cachePatch("ENDPERLI")
		end
	else
		print("'endperli' patch missing")
		return
	end
	if v.patchExists("DIRTBLCI")
		if v.dirtblci == nil
			v.dirtblci = v.cachePatch("DIRTBLCI")
		end
	else
		print("'dirtblci' patch missing")
		return
	end
	if v.patchExists("STEVEBAR")
		if v.stevebar == nil
			v.stevebar = v.cachePatch("STEVEBAR")
		end
	else
		print("'stevebar' patch missing")
		return
	end
	--"247:247"
	--Set block and pearl icon scale
	local bloicosc = 20*FRACUNIT/39
	local pericosc = 21*FRACUNIT/20
	--Draw HUD background
	v.draw(15,81,v.stevebar,V_SNAPTOLEFT)
	--Draw block icon
	v.drawFill(21,88,18,18,v.colstvre|V_SNAPTOLEFT)
	v.drawFill(21,88,18,FixedInt(18*cdownleft(p,true)),v.colstvus|V_SNAPTOLEFT)
	v.drawScaled(21*FRACUNIT,88*FRACUNIT,bloicosc,v.dirtblci,V_SNAPTOLEFT)
	--Draw pearl icon
	v.drawFill(21,114,18,18,v.colstvre|V_SNAPTOLEFT)
	v.drawFill(21,114,18,FixedInt(18*cdownleft(p,false)),v.colstvus|V_SNAPTOLEFT)
	v.drawScaled(21*FRACUNIT,114*FRACUNIT,pericosc,v.endperli,V_SNAPTOLEFT)
end
end, "game")


addHook("MobjMoveCollide", function(tmthing,thing)
--Make sure the pearl will collide with dirt blocks
	if thing.type == MT_DIRTBLOC and thing.flags & MF_SOLID
		if tmthing.z <= thing.z + thing.height and tmthing.z >= thing.z
			return true
		end
	end
end,MT_ENDPEARL)